module keyboard_scan(
	clk,
	rstn,
	col,
	row,
	key);

	//---Ports declearation: generated by Robei---
	input clk;
	input rstn;
	input [3:0] col;
	output [3:0] row;
	output [15:0] key;

	wire clk;
	wire rstn;
	wire [3:0] col;
	reg [3:0] row;
	reg [15:0] key;

	//----Code starts here: integrated by Robei-----
	reg [31:0] cnt;
	reg scan_clk1;
	reg scan_clk2;
	
	//2λȫ෴ʱ
	    always@(posedge clk or negedge rstn) 
	    begin
	        if(!rstn)
	        begin
	            cnt <= 1'b0;
	            scan_clk1 <=1'b0;
	            scan_clk2 <=1'b1;
	        end
	     //   else if(cnt == 32'd2499) 
					else if(cnt == 32'd24)//for test
	        begin
	            cnt <= 1'b0;
	            scan_clk1 <= ~scan_clk1;
	            scan_clk2 <= ~scan_clk2;
	        end
	        else 
	        begin
	            cnt <= cnt + 1'b1;
	            scan_clk1 <= scan_clk1;
	            scan_clk2 <= scan_clk2;
	        end
	    end
	
	    always@(posedge scan_clk1 or negedge rstn)
	    begin
	        if(!rstn)
	            row <= 4'b1110;
	        else
	            row <= {row[2:0], row[3]};//ɨ
	    end
	    
	    always@(posedge scan_clk2 or negedge rstn)begin
	        if(!rstn)
	            key <= 16'h0;
	        else case(row)
	            4'b1110	: key[3:0] 			<= 	col			;//
	            4'b1101	: key[7:4] 			<= 	col			;
	            4'b1011	: key[11:8] 		<= 	col			;
	            4'b0111	: key[15:12]		<= 	col			;
	            default	: key								<= 	16'h0	;
	        endcase
	    end
	
	
	
endmodule    //keyboard_scan

